unit DelphiCleaner1;

interface

{ Delphi Cleaner (C)2002 by Paul TOTH <tothpaul@free.fr>
 http://tothpaul.free.fr

 to remove a Delphi version when the installer fail :)
}

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, Registry, ShellAPI;

type
  TForm1 = class(TForm)
    CheckList: TCheckListBox;
    btDelete: TButton;
    Cancel: TButton;
    Refresh: TButton;
    Label1: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckListClickCheck(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
  private
    { Dclarations prives }
    Reg:TRegistry;
    Lst:TStrings;
    Bpl:TStrings;
    RegIndex:integer;
    RegCount:integer;
    DirIndex:integer;
    DirCount:integer;
    BplIndex:integer;
    BplCount:integer;
    DllIndex:integer;
    DllCount:integer;
    procedure Title(s:string);
    procedure Grayed(s:string);
    procedure PackagesIn(Path,Ext:string);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function WindowsDirectory:string;
var
 b:array[0..MAX_PATH] of char;
begin
 GetWindowsDirectory(b,SizeOf(b));
 Result:=b;
end;

function SystemDirectory:string;
var
 b:array[0..MAX_PATH] of char;
begin
 GetSystemDirectory(b,SizeOf(b));
 Result:=b;
end;

function Trash(sFileName : string ): integer;
var
  fos : TSHFileOpStruct;
begin
//  ShowMessage(sFileName);
  FillChar( fos, SizeOf( fos ), 0 );
  with fos do begin
    wFunc := FO_DELETE;
    pFrom := PChar( sFileName + #0 );
    fFlags := FOF_ALLOWUNDO or FOF_NOCONFIRMATION;// or FOF_SILENT};
  end;
  Result:=ShFileOperation(fos);
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
 Reg:=TRegistry.Create;
 Lst:=TStringList.Create;
 Bpl:=TStringList.Create;
 TStringList(Bpl).Sorted:=True;
 TStringList(Bpl).Duplicates:=dupIgnore;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Reg.Free;
 Lst.Free;
 Bpl.Free;
end;

procedure TForm1.Title(s:string);
var
 i:integer;
begin
 i:=CheckList.Items.Add(s);
 CheckList.Header[i]:=True;
end;

procedure TForm1.Grayed(s:string);
var
 i:integer;
begin
 i:=CheckList.Items.Add(s);
 CheckList.ItemEnabled[i]:=False;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
 i:integer;
 f:TSearchRec;
 win,sys:string;
 s,p:string;
 l:integer;
begin
// let's take a look into the registry
 CheckList.Clear;

// Any Delphi version registered ?
 Reg.RootKey:=HKEY_LOCAL_MACHINE;
 Title('Registered Delphi version');
 if not Reg.OpenKey('\Software\Borland\Delphi',False) then begin
  Grayed('none');
  RegIndex:=-1;
  RegCount:= 0;
 end else begin
  Reg.GetKeyNames(Lst);
  RegIndex:=CheckList.Count-1;
  CheckList.Items.AddStrings(Lst);
  RegCount:=CheckList.Count-RegIndex-1;
 end;

// Look at Delphi Directory
 Title('Delphi directories');
 DirIndex:=CheckList.Count-1;
 DirCount:=0;
 if FindFirst('C:\Program Files\Borland\Delphi*',faDirectory,f)=0 then begin
  repeat
   CheckList.Items.Add(f.Name);
   Inc(DirCount);
  until FindNext(f)<>0;
 end else begin
  Grayed('none');
 end;
 FindClose(f);

// Now Windows Directory
 Title('Delphi packages (or look like so)');
 BplIndex:=CheckList.Items.Count-1;
 Bpl.Clear;
 win:=WindowsDirectory+'\';
 sys:=SystemDirectory+'\';
 PackagesIn(win,'*.BPL');
 PackagesIn(sys,'*.BPL');
 PackagesIn(win,'*50.*');
 PackagesIn(sys,'*60.*');
 PackagesIn(sys,'*70.*');
 Lst.Assign(Bpl);
 Bpl.Clear;
 for i:=0 to Lst.Count-1 do begin
  s:=Lst[i];
  p:=ExtractFilePath(s);
  l:=Length(p);
  PackagesIn(p,copy(s,l+1,Length(s)-l-3)+'*');
 end;
 BplCount:=Bpl.Count;
 if Bpl.Count=0 then Grayed('none') else begin
  CheckList.Items.AddStrings(Bpl);
 end;

// Shared DLLs
 Title('Shared DLLs');
 if not Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\SharedDLLs',False) then begin
  Grayed('none');
  RegIndex:=-1;
  RegCount:= 0;
 end else begin
  Reg.GetValueNames(Lst);
  TStringList(Lst).Sort;
  DllIndex:=CheckList.Count-1;
  CheckList.Items.AddStrings(Lst);
  DllCount:=CheckList.Count-DllIndex-1;
 end;
end;

procedure TForm1.PackagesIn(Path,Ext:string);
var
 f:TSearchRec;
begin
// grayed(Path+':'+Ext);
 if FindFirst(Path+Ext,faAnyFile,f)=0 then begin
  repeat
   Bpl.Add(Path+f.Name);
  until FindNext(f)<>0;
 end;
 FindClose(f);
end;

procedure TForm1.CheckListClickCheck(Sender: TObject);
var
 i:integer;
 s:string;
 j:integer;
 k:integer;
 first,last:integer;
 ss:string;
begin
 i:=CheckList.ItemIndex;
 if i>=BplIndex then begin
  if CheckList.State[i]=cbChecked then begin
   s:=CheckList.Items[i];
   Delete(s,1,Length(s)-(2+4));
   SetLength(s,3); // "VCL70.BPL" -> "70."
   if (s[1] in ['0'..'9']) and (s[2] in ['0'..'9']) then begin
    if i>=DllIndex then begin
     first:=DllIndex;
     last :=first+DllCount-1;
    end else begin
     first:=BplIndex;
     last :=first+BplCount-1;
    end;
    for j:=first to last-1 do begin
     if (j<>i)and(pos(s,CheckList.Items[j])>0)and(CheckList.State[j]=cbUnChecked) then begin
      if MessageDlg('Should I select *'+s+'* ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
       for k:=j to last-1 do begin
        ss:=CheckList.Items[k];
        if (k<>i)and(pos(s,ss)>0) then begin
         if (pos('MSVC',UpperCase(ss))=0)
         or (MessageDlg('Should I select '+ss+', it look like a Miccrosoft C++ DLL ?',mtConfirmation,[mbYes,mbNo],0)=mrYes) then
           CheckList.State[k]:=cbChecked;
        end;
       end;
      end;
      exit;
     end;
    end;
   end;
  end;
 end;
end;

procedure TForm1.CancelClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.btDeleteClick(Sender: TObject);
var
 i,CountReg,CountDir,CountBpl,CountDll:integer;
 s:string;
begin
 Lst.Clear;
 CountReg:=0;
 for i:=RegIndex to RegIndex+RegCount do begin
  if CheckList.State[i]=cbChecked then begin
   Lst.Add(CheckList.Items[i]);
   inc(CountReg);
  end;
 end;
 CountDir:=0;
 for i:=DirIndex to DirIndex+DirCount do begin
  if CheckList.State[i]=cbChecked then begin
   Lst.Add(CheckList.Items[i]);
   inc(CountDir);
  end;
 end;
 CountBpl:=0;
 for i:=BplIndex to BplIndex+BplCount do begin
  if CheckList.State[i]=cbChecked then begin
   Lst.Add(CheckList.Items[i]);
   inc(CountBpl);
  end;
 end;
 CountDll:=0;
 for i:=DllIndex to DllIndex+DllCount do begin
  if CheckList.State[i]=cbChecked then begin
   s:=CheckList.Items[i];
   if (pos('MSVC',UpperCase(s))=0)
   or (MessageDlg('Should I select '+s+', it look like a Miccrosoft C++ DLL ?',mtConfirmation,[mbYes,mbNo],0)=mrYes) then
    Lst.Add(s);
   inc(CountDll);
  end;
 end;
 if lst.Count=0 then begin
  ShowMessage('Select some items to delete them :)');
  exit;
 end;
 if MessageDlg('Should I delete all the selected items ?',mtWarning,[mbYes,mbNo],0)=mrNo then exit;
 // Registry
 if Reg.OpenKey('\Software\Borland\Delphi',False) then
  for i:=0 to CountReg-1 do begin
   Reg.DeleteKey(Lst[i]);
  end;

 for i:=0 to CountDir-1 do Trash('C:\Program Files\Borland\'+Lst[i+CountReg]);

 s:='';
 for i:=0 to CountBpl-1 do s:=s+Lst[i+CountReg+CountDir]+#0;
 Trash(s);

 if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\SharedDLLs',False) then
  for i:=0 to CountDll-1 do begin
   Reg.DeleteValue(Lst[i+CountReg+CountDir+CountBpl])
   //ShowMessage('delreg  '+Lst[i+CountReg+CountDir+CountBpl])
  end;

 Refresh.Click;
end;

end.
